Package org.pentaho.reporting.libraries.formula.parser

## Class JavaCharStream

- java.lang.Object
- - org.pentaho.reporting.libraries.formula.parser.JavaCharStream

-     public class JavaCharStream
      extends java.lang.Object

  An implementation of interface CharStream, where the stream is assumed to contain only ASCII characters (with java-like unicode escape processing).

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `int` | `bufpos` | Position in buffer.
    `static boolean` | `staticFlag` | Whether parser is static.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JavaCharStream​(java.io.InputStream dstream)` | Constructor.
    `JavaCharStream​(java.io.InputStream dstream, int startline, int startcolumn)` | Constructor.
    `JavaCharStream​(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)` | Constructor.
    `JavaCharStream​(java.io.InputStream dstream, java.lang.String encoding)` | Constructor.
    `JavaCharStream​(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn)` | Constructor.
    `JavaCharStream​(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn, int buffersize)` | Constructor.
    `JavaCharStream​(java.io.Reader dstream)` | Constructor.
    `JavaCharStream​(java.io.Reader dstream, int startline, int startcolumn)` | Constructor.
    `JavaCharStream​(java.io.Reader dstream, int startline, int startcolumn, int buffersize)` | Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `adjustBeginLineColumn​(int newLine, int newCol)` | Method to adjust line and column numbers for the start of a token.
    `void` | `backup​(int amount)` | Retreat.
    `char` | `BeginToken()` |
    `void` | `Done()` | Set buffers back to null when finished.
    `int` | `getBeginColumn()` |
    `int` | `getBeginLine()` |
    `int` | `getColumn()` | Deprecated.
    `int` | `getEndColumn()` | Get end column.
    `int` | `getEndLine()` | Get end line.
    `java.lang.String` | `GetImage()` |
    `int` | `getLine()` | Deprecated.
    `char[]` | `GetSuffix​(int len)` |
    `char` | `readChar()` | Read a character.
    `void` | `ReInit​(java.io.InputStream dstream)` | Reinitialise.
    `void` | `ReInit​(java.io.InputStream dstream, int startline, int startcolumn)` | Reinitialise.
    `void` | `ReInit​(java.io.InputStream dstream, int startline, int startcolumn, int buffersize)` | Reinitialise.
    `void` | `ReInit​(java.io.InputStream dstream, java.lang.String encoding)` | Reinitialise.
    `void` | `ReInit​(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn)` | Reinitialise.
    `void` | `ReInit​(java.io.InputStream dstream, java.lang.String encoding, int startline, int startcolumn, int buffersize)` | Reinitialise.
    `void` | `ReInit​(java.io.Reader dstream)` | Reinitialise.
    `void` | `ReInit​(java.io.Reader dstream, int startline, int startcolumn)` | Reinitialise.
    `void` | `ReInit​(java.io.Reader dstream, int startline, int startcolumn, int buffersize)` | Reinitialise.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### staticFlag

          public static final boolean staticFlag

      Whether parser is static.
      See Also:
        Constant Field Values

    - #### bufpos

          public int bufpos

      Position in buffer.

  - ### Constructor Detail

    - #### JavaCharStream

          public JavaCharStream​(java.io.Reader dstream,
                                int startline,
                                int startcolumn,
                                int buffersize)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream​(java.io.Reader dstream,
                                int startline,
                                int startcolumn)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream​(java.io.Reader dstream)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream,
                                java.lang.String encoding,
                                int startline,
                                int startcolumn,
                                int buffersize)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream,
                                int startline,
                                int startcolumn,
                                int buffersize)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream,
                                java.lang.String encoding,
                                int startline,
                                int startcolumn)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream,
                                int startline,
                                int startcolumn)

      Constructor.

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream,
                                java.lang.String encoding)
                         throws java.io.UnsupportedEncodingException

      Constructor.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### JavaCharStream

          public JavaCharStream​(java.io.InputStream dstream)

      Constructor.

  - ### Method Detail

    - #### BeginToken

          public char BeginToken()
                          throws java.io.IOException

      Returns:
        starting character for token.
      Throws:
        `java.io.IOException`

    - #### readChar

          public char readChar()
                        throws java.io.IOException

      Read a character.
      Throws:
        `java.io.IOException`

    - #### getColumn

          @Deprecated
          public int getColumn()

      Deprecated.

    - #### getLine

          @Deprecated
          public int getLine()

      Deprecated.

    - #### getEndColumn

          public int getEndColumn()

      Get end column.

    - #### getEndLine

          public int getEndLine()

      Get end line.

    - #### getBeginColumn

          public int getBeginColumn()

      Returns:
        column of token start

    - #### getBeginLine

          public int getBeginLine()

      Returns:
        line number of token start

    - #### backup

          public void backup​(int amount)

      Retreat.

    - #### ReInit

          public void ReInit​(java.io.Reader dstream,
                             int startline,
                             int startcolumn,
                             int buffersize)

      Reinitialise.

    - #### ReInit

          public void ReInit​(java.io.Reader dstream,
                             int startline,
                             int startcolumn)

      Reinitialise.

    - #### ReInit

          public void ReInit​(java.io.Reader dstream)

      Reinitialise.

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream,
                             java.lang.String encoding,
                             int startline,
                             int startcolumn,
                             int buffersize)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream,
                             int startline,
                             int startcolumn,
                             int buffersize)

      Reinitialise.

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream,
                             java.lang.String encoding,
                             int startline,
                             int startcolumn)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream,
                             int startline,
                             int startcolumn)

      Reinitialise.

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream,
                             java.lang.String encoding)
                      throws java.io.UnsupportedEncodingException

      Reinitialise.
      Throws:
        `java.io.UnsupportedEncodingException`

    - #### ReInit

          public void ReInit​(java.io.InputStream dstream)

      Reinitialise.

    - #### GetImage

          public java.lang.String GetImage()

      Returns:
        token image as String

    - #### GetSuffix

          public char[] GetSuffix​(int len)

      Returns:
        suffix

    - #### Done

          public void Done()

      Set buffers back to null when finished.

    - #### adjustBeginLineColumn

          public void adjustBeginLineColumn​(int newLine,
                                            int newCol)

      Method to adjust line and column numbers for the start of a token.